/*!
 * @author electricessence / https://github.com/electricessence/
 * Licensing: MIT
 * Although most of the following code is written from scratch, it is
 * heavily influenced by Q (https://github.com/kriskowal/q) and uses some of Q's spec.
 */
!function(t){if("object"==typeof module&&"object"==typeof module.exports){var e=t(require,exports);void 0!==e&&(module.exports=e)}else"function"==typeof define&&define.amd&&define(["require","exports","../Types","../Threading/deferImmediate","../Disposable/DisposableBase","../Exceptions/InvalidOperationException","../Exceptions/ArgumentException","../Exceptions/ArgumentNullException","../Disposable/ObjectPool","../Collections/Set","../Threading/defer","../Disposable/ObjectDisposedException","../../extends"],t)}(function(t,e){"use strict";function n(t){return c["default"].hasMemberOfType(t,I,c["default"].FUNCTION)}function r(t,e,r){var o=e?e(t):t;return o&&n(o)?C.wrap(o):r(o)}function o(t,e,n){try{var r=n?n(e):e;return t&&t.resolve(r),null}catch(o){return t&&t.reject(o),o}}function i(t,e,n,r){try{var o=r?r(n):n;t&&t(o)}catch(i){e&&e(i)}}function s(t,e,n){t instanceof P?t.doneNow(e,n):t.then(e,n)}function u(t,e,n){return t instanceof P?t.thenSynchronous(e,n):t.then(e,n)}function l(){return new g.ObjectDisposedException("TSDNPromise","An underlying promise-result was disposed.")}Object.defineProperty(e,"__esModule",{value:!0});var c=t("../Types"),a=t("../Threading/deferImmediate"),f=t("../Disposable/DisposableBase"),p=t("../Exceptions/InvalidOperationException"),h=t("../Exceptions/ArgumentException"),d=t("../Exceptions/ArgumentNullException"),w=t("../Disposable/ObjectPool"),v=t("../Collections/Set"),y=t("../Threading/defer"),g=t("../Disposable/ObjectDisposedException"),m=t("../../extends"),_=m["default"],b=void 0,j=null,D="Promise",S=D+"State",I="then",N="target",x=function(t){function e(e,n,r){var o=t.call(this)||this;return o._state=e,o._result=n,o._error=r,o._disposableObjectName=S,o}return _(e,t),e.prototype._onDispose=function(){this._state=b,this._result=b,this._error=b},e.prototype.getState=function(){return this._state},Object.defineProperty(e.prototype,"state",{get:function(){return this._state},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isPending",{get:function(){return this.getState()===C.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isSettled",{get:function(){return this.getState()!=C.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isFulfilled",{get:function(){return this.getState()===C.State.Fulfilled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isRejected",{get:function(){return this.getState()===C.State.Rejected},enumerable:!0,configurable:!0}),e.prototype.getResult=function(){return this._result},Object.defineProperty(e.prototype,"result",{get:function(){return this.throwIfDisposed(),this.getResult()},enumerable:!0,configurable:!0}),e.prototype.getError=function(){return this._error},Object.defineProperty(e.prototype,"error",{get:function(){return this.throwIfDisposed(),this.getError()},enumerable:!0,configurable:!0}),e}(f.DisposableBase);e.PromiseState=x;var P=function(t){function e(){var e=t.call(this,C.State.Pending)||this;return e._disposableObjectName=D,e}return _(e,t),e.prototype.thenThis=function(t,e){return this.doneNow(t,e),this},e.prototype.then=function(t,e){var n=this;return this.throwIfDisposed(),new C(function(r,o){n.doneNow(function(e){return i(r,o,e,t)},function(t){return e?i(r,o,t,e):o(t)})})},e.prototype.thenAllowFatal=function(t,e){var n=this;return this.throwIfDisposed(),new C(function(r,o){n.doneNow(function(e){return r(t?t(e):e)},function(t){return o(e?e(t):t)})})},e.prototype.done=function(t,e){var n=this;y.defer(function(){return n.doneNow(t,e)})},e.prototype.delayFromNow=function(t){var e=this;return void 0===t&&(t=0),this.throwIfDisposed(),new C(function(n,r){y.defer(function(){e.doneNow(function(t){return n(t)},function(t){return r(t)})},t)},(!0))},e.prototype.delayAfterResolve=function(t){var e=this;return void 0===t&&(t=0),this.throwIfDisposed(),this.isSettled?this.delayFromNow(t):new C(function(n,r){e.doneNow(function(e){return y.defer(function(){return n(e)},t)},function(e){return y.defer(function(){return r(e)},t)})},(!0))},e.prototype["catch"]=function(t){return this.then(b,t)},e.prototype.catchAllowFatal=function(t){return this.thenAllowFatal(b,t)},e.prototype["finally"]=function(t){return this.then(t,t)},e.prototype.finallyAllowFatal=function(t){return this.thenAllowFatal(t,t)},e.prototype.finallyThis=function(t,e){var n=e?t:function(){return a.deferImmediate(t)};return this.doneNow(n,n),this},e}(x);e.PromiseBase=P;var E=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return _(e,t),e.prototype.doneNow=function(t,e){switch(this.throwIfDisposed(),this.state){case C.State.Fulfilled:t&&t(this._result);break;case C.State.Rejected:e&&e(this._error)}},e.prototype.thenSynchronous=function(t,e){this.throwIfDisposed();try{switch(this.state){case C.State.Fulfilled:return t?r(this._result,t,C.resolve):this;case C.State.Rejected:return e?r(this._error,e,C.resolve):this}}catch(n){return new F(n)}throw new Error("Invalid state for a resolved promise.")},e}(P);e.Resolvable=E;var A=function(t){function e(e,n,r){var o=t.call(this)||this;return o._result=n,o._error=r,o._state=e,o}return _(e,t),e}(E);e.Resolved=A;var O=function(t){function e(e){return t.call(this,C.State.Fulfilled,e)||this}return _(e,t),e}(A);e.Fulfilled=O;var F=function(t){function e(e){return t.call(this,C.State.Rejected,b,e)||this}return _(e,t),e}(A);e.Rejected=F;var R=function(t){function e(e){var r=t.call(this)||this;if(r._target=e,!e)throw new d.ArgumentNullException(N);if(!n(e))throw new h.ArgumentException(N,"Must be a promise-like object.");return e.then(function(t){r._state=C.State.Fulfilled,r._result=t,r._error=b,r._target=b},function(t){r._state=C.State.Rejected,r._error=t,r._target=b}),r}return _(e,t),e.prototype.thenSynchronous=function(e,n){this.throwIfDisposed();var r=this._target;return r?new C(function(t,o){s(r,function(n){return i(t,o,n,e)},function(e){return n?i(t,null,e,n):o(e)})},(!0)):t.prototype.thenSynchronous.call(this,e,n)},e.prototype.doneNow=function(e,n){this.throwIfDisposed();var r=this._target;r?s(r,e,n):t.prototype.doneNow.call(this,e,n)},e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._target=b},e}(E),C=function(t){function e(e,n){void 0===n&&(n=!1);var r=t.call(this)||this;return e&&r.resolveUsing(e,n),r}return _(e,t),e.prototype.thenSynchronous=function(n,r){if(this.throwIfDisposed(),this._state)return t.prototype.thenSynchronous.call(this,n,r);var o=new e;return(this._waiting||(this._waiting=[])).push(M.PromiseCallbacks.init(n,r,o)),o},e.prototype.doneNow=function(e,n){return this.throwIfDisposed(),this._state?t.prototype.doneNow.call(this,e,n):void(this._waiting||(this._waiting=[])).push(M.PromiseCallbacks.init(e,n))},e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._resolvedCalled=b},e.prototype.resolveUsing=function(t,n){var r=this;if(void 0===n&&(n=!1),!t)throw new d.ArgumentNullException("resolver");if(this._resolvedCalled)throw new p.InvalidOperationException(".resolve() already called.");if(this.state)throw new p.InvalidOperationException("Already resolved: "+e.State[this.state]);this._resolvedCalled=!0;var o=0,i=function(t){o?console.warn(o==-1?"Rejection called multiple times":"Rejection called after fulfilled."):(o=-1,r._resolvedCalled=!1,r.reject(t))},s=function(t){o?console.warn(1==o?"Fulfill called multiple times":"Fulfill called after rejection."):(o=1,r._resolvedCalled=!1,r.resolve(t))};n?t(s,i):a.deferImmediate(function(){return t(s,i)})},e.prototype._emitDisposalRejection=function(t){var e=t.wasDisposed;return e&&this._rejectInternal(l()),e},e.prototype._resolveInternal=function(t){var r=this;if(!this.wasDisposed){for(;t instanceof P;){var i=t;if(this._emitDisposalRejection(i))return;switch(i.state){case e.State.Pending:return void i.doneNow(function(t){return r._resolveInternal(t)},function(t){return r._rejectInternal(t)});case e.State.Rejected:return void this._rejectInternal(i.error);case e.State.Fulfilled:t=i.result}}if(n(t))t.then(function(t){return r._resolveInternal(t)},function(t){return r._rejectInternal(t)});else{this._state=e.State.Fulfilled,this._result=t,this._error=b;var s=this._waiting;if(s){this._waiting=b;for(var u=0,l=s;u<l.length;u++){var c=l[u],a=c.onFulfilled,f=c.promise;M.PromiseCallbacks.recycle(c),o(f,t,a)}s.length=0}}}},e.prototype._rejectInternal=function(t){if(!this.wasDisposed){this._state=e.State.Rejected,this._error=t;var n=this._waiting;if(n){this._waiting=null;for(var r=0,i=n;r<i.length;r++){var s=i[r],u=s.onRejected,l=s.promise;M.PromiseCallbacks.recycle(s),u?o(l,t,u):l&&l.reject(t)}n.length=0}}},e.prototype.resolve=function(t,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),t==this)throw new p.InvalidOperationException("Cannot resolve a promise as itself.");if(this._state){if(!n||this._state==e.State.Fulfilled&&this._result===t)return;throw new p.InvalidOperationException("Changing the fulfilled state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new p.InvalidOperationException(".resolve() already called.")}else this._resolveInternal(t)},e.prototype.reject=function(t,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),this._state){if(!n||this._state==e.State.Rejected&&this._error===t)return;throw new p.InvalidOperationException("Changing the rejected state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new p.InvalidOperationException(".resolve() already called.")}else this._rejectInternal(t)},e}(E);e.TSDNPromise=C,e.Promise=C;var T=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return _(e,t),e.prototype.map=function(t){var n=this;return this.throwIfDisposed(),new e(function(e){n.doneNow(function(n){return e(n.map(t))})},(!0))},e.prototype.reduce=function(t,e){return this.thenSynchronous(function(n){return n.reduce(t,e)})},e.fulfilled=function(t){return new e(function(e){return t},(!0))},e}(C);e.ArrayPromise=T;var k="PromiseCollection",B=function(t){function e(e){var n=t.call(this)||this;return n._disposableObjectName=k,n._source=e&&e.slice()||[],n}return _(e,t),e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._source.length=0,this._source=null},Object.defineProperty(e.prototype,"promises",{get:function(){return this.throwIfDisposed(),this._source.slice()},enumerable:!0,configurable:!0}),e.prototype.all=function(){return this.throwIfDisposed(),C.all(this._source)},e.prototype.race=function(){return this.throwIfDisposed(),C.race(this._source)},e.prototype.waitAll=function(){return this.throwIfDisposed(),C.waitAll(this._source)},e.prototype.map=function(t){var e=this;return this.throwIfDisposed(),new T(function(n){e.all().doneNow(function(e){return n(e.map(t))})},(!0))},e.prototype.pipe=function(t){return this.throwIfDisposed(),new e(this._source.map(function(e){return u(e,t)}))},e.prototype.reduce=function(t,e){return this.throwIfDisposed(),C.wrap(this._source.reduce(function(e,n,r,o){return u(e,function(e){return u(n,function(n){return t(e,n,r,o)})})},n(e)?e:new O(e)))},e}(f.DisposableBase);e.PromiseCollection=B;var M;!function(t){
// 		if(c) getPool().add(c);
// 	}
//
// }
//
// export function recycle<T>(c:PromiseBase<T>):void
// {
// 	if(!c) return;
// 	if(c instanceof Promise && c.constructor==Promise) pending.recycle(c);
// 	else c.dispose();
// }
var e;!function(t){function e(){return i||(i=new w.ObjectPool(40,n,function(t){t.onFulfilled=j,t.onRejected=j,t.promise=j}))}function n(){return{onFulfilled:j,onRejected:j,promise:j}}function r(t,n,r){var o=e().take();return o.onFulfilled=t||void 0,o.onRejected=n||void 0,o.promise=r,o}function o(t){e().add(t)}var i;t.init=r,t.recycle=o}(e=t.PromiseCallbacks||(t.PromiseCallbacks={}))}(M||(M={})),function(t){function e(e){return new t(e)}function r(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new d.ArgumentNullException("promises");return new B((t instanceof Array?t:[t]).concat(e))}function o(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new d.ArgumentNullException("promises");var r=(t instanceof Array?t:[t]).concat(e);return!r.length||r.every(function(t){return!t})?new T(function(t){return t(r)},(!0)):new T(function(t,e){var n=[],o=r.length;n.length=o;for(var i=new v.Set(r.map(function(t,e){return e})),s=function(){e=b,t=b,r.length=0,r=b,i.dispose(),i=b},u=function(){var e=t;e&&!i.count&&(s(),e(n))},l=function(e,r){t&&(n[r]=e,i.remove(r),u())},c=function(t){var n=e;n&&(s(),n(t))},a=function(t){var e=r[t];e?e.then(function(e){return l(e,t)},c):i.remove(t),u()},f=0;i&&f<o;f++)a(f)})}function i(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new d.ArgumentNullException("promises");var r=(t instanceof Array?t:[t]).concat(e);return!r.length||r.every(function(t){return!t})?new T(function(t){return t(r)},(!0)):new T(function(t,e){for(var n=r.length,o=new v.Set(r.map(function(t,e){return e})),i=function(){e=j,t=j,o.dispose(),o=j},s=function(){var e=t;e&&!o.count&&(i(),e(r))},u=function(t){o&&(o.remove(t),s())},l=function(t){var e=r[t];e?e.then(function(e){return u(t)},function(e){return u(t)}):u(t)},c=0;o&&c<n;c++)l(c)})}function s(e){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];var o=e&&(e instanceof Array?e:[e]).concat(n);if(!o||!o.length||!(o=o.filter(function(t){return null!=t})).length)throw new h.ArgumentException("Nothing to wait for.");var i=o.length;if(1==i)return p(o[0]);for(var s=0;s<i;s++){var u=o[s];if(u instanceof P&&u.isSettled)return u}return new t(function(t,e){for(var n=function(){e=j,t=j,o.length=0,o=j},r=function(t,e){t&&(n(),t(e))},i=function(e){return r(t,e)},s=function(t){return r(e,t)},u=0,l=o;u<l.length;u++){var c=l[u];if(!t)break;c.then(i,s)}})}function u(t){return n(t)?p(t):new O(t)}function l(e,n){return void 0===n&&(n=!1),new t(e,n)}function c(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new d.ArgumentNullException("resolutions");return new B((t instanceof Array?t:[t]).concat(e).map(function(t){return u(t)}))}function a(e,n){return new B(e.map(function(e){return new t(function(t,r){try{t(n(e))}catch(o){r(o)}})}))}function f(t){return new F(t)}function p(t){if(!t)throw new d.ArgumentNullException(N);return n(t)?t instanceof P?t:new R(t):new O(t)}function w(t){if(!t)throw new d.ArgumentNullException(I);return new R({then:t})}var y;!function(t){t[t.Pending=0]="Pending",t[t.Fulfilled=1]="Fulfilled",t[t.Rejected=-1]="Rejected"}(y=t.State||(t.State={})),Object.freeze(y),t.factory=e,t.group=r,t.all=o,t.waitAll=i,t.race=s,t.resolve=u,t.using=l,t.resolveAll=c,t.map=a,t.reject=f,t.wrap=p,t.createFrom=w}(C=e.TSDNPromise||(e.TSDNPromise={})),e.TSDNPromise=C,e.Promise=C,e["default"]=C});
//# sourceMappingURL=Promise.js.map